// on domready events
window.addEvent('domready', function () {
    /*
    * Global constants
    *
    ***************************************************************************/
    // poll time for the Gpio's (in milliseconds)
    var POLL_TIME_MS = 500;

    /*
    * Global variables
    *
    ***************************************************************************/
    var toggleLedState0 = false;
    var toggleLedState1 = false;
    var toggleLedState2 = false;
    var toggleLedState3 = false;
    var toggleLedState4 = false;
    var toggleLedState5 = false;
    var toggleLedState6 = false;
    var toggleLedState7 = false;

    var toggleSwitchState0 = false;
    var toggleSwitchState1 = false;
    var toggleSwitchState2 = false;
    var toggleSwitchState3 = false;
    var toggleSwitchState4 = false;
    var toggleSwitchState5 = false;
    var toggleSwitchState6 = false;
    var toggleSwitchState7 = false;

    var togglePushbuttonState0 = false;
    var togglePushbuttonState1 = false;
    var togglePushbuttonState2 = false;
    var togglePushbuttonState3 = false;
    var togglePushbuttonState4 = false;
    var togglePushbuttonState5 = false;
    var togglePushbuttonState6 = false;
    var togglePushbuttonState7 = false;

    var Response = false;
    var startStop = false;

    var name = new Array();
    var location = new Array();
    var size = new Array();

    var buc = new Array();
    var newLocaUpld = new Array();

    var nameToSend = new Array();
    var locationToSend = new Array();
    var sizeToSend = new Array();
    var IsLastFile = false;

    var alreadyOl = false;

    var list = document.id('select');
    var showRes = document.id('status');

    var links;

    /*
    * Function prototypes (only for reference)
    *
    ***************************************************************************
    var PollGpios();
    var GetList();
    var FileUpload();
    var FileDownload(FileName, FileLocation, FileSize);
    var FileDelete(FileName, FileLocation, FileSize, IsLastFile);
    var LedStateChange(LedNr);
    var ResetGpios();
    ***************************************************************************/

    /*
    * Function to send request for state of the LED's
    *
    ***************************************************************************/
    var LedStateToServer = new Request({
        method: 'post',
        onSuccess: function (responseText) {
            Response = true;
        },
        onFailure: function () {
            Response = false;
        }
    });

    /*
    * Function to send request for state of the Pushbuttons and Switches
    *
    ***************************************************************************/
    // 'GET' request object instance
    var objGetReq = new Request({
        method: 'get',
        onSuccess: function (responseText, responseXML) {
            var set = Slick.search(responseXML, 'SET');
            set.each(function (item, index) {
                // TODO: instead of ".get('text')" -> ".nodeValue"
                var btnState = item.getElement('PUSHBUTTONS_STATE').get('text');
                var swState = item.getElement('SWITCHES_STATE').get('text');

                // toggle pushbutton pictures
                document.getElementById('btnu').src = (btnState & 0x10) ? "pictures/pushbuttons/atlys_btnu_on.jpg" : "pictures/pushbuttons/atlys_btnu_off.jpg";
                document.getElementById('btnl').src = (btnState & 0x08) ? "pictures/pushbuttons/atlys_btnl_on.jpg" : "pictures/pushbuttons/atlys_btnl_off.jpg";
                document.getElementById('btnc').src = (btnState & 0x04) ? "pictures/pushbuttons/atlys_btnc_on.jpg" : "pictures/pushbuttons/atlys_btnc_off.jpg";
                document.getElementById('btnr').src = (btnState & 0x02) ? "pictures/pushbuttons/atlys_btnr_on.jpg" : "pictures/pushbuttons/atlys_btnr_off.jpg";
                document.getElementById('btnd').src = (btnState & 0x01) ? "pictures/pushbuttons/atlys_btnd_on.jpg" : "pictures/pushbuttons/atlys_btnd_off.jpg";

                // toggle switch pictures
                document.getElementById('sw7').src = (swState & 0x80) ? "pictures/switches/atlys_sw7_on.jpg" : "pictures/switches/atlys_sw7_off.jpg";
                document.getElementById('sw6').src = (swState & 0x40) ? "pictures/switches/atlys_sw6_on.jpg" : "pictures/switches/atlys_sw6_off.jpg";
                document.getElementById('sw5').src = (swState & 0x20) ? "pictures/switches/atlys_sw5_on.jpg" : "pictures/switches/atlys_sw5_off.jpg";
                document.getElementById('sw4').src = (swState & 0x10) ? "pictures/switches/atlys_sw4_on.jpg" : "pictures/switches/atlys_sw4_off.jpg";
                document.getElementById('sw3').src = (swState & 0x08) ? "pictures/switches/atlys_sw3_on.jpg" : "pictures/switches/atlys_sw3_off.jpg";
                document.getElementById('sw2').src = (swState & 0x04) ? "pictures/switches/atlys_sw2_on.jpg" : "pictures/switches/atlys_sw2_off.jpg";
                document.getElementById('sw1').src = (swState & 0x02) ? "pictures/switches/atlys_sw1_on.jpg" : "pictures/switches/atlys_sw1_off.jpg";
                document.getElementById('sw0').src = (swState & 0x01) ? "pictures/switches/atlys_sw0_on.jpg" : "pictures/switches/atlys_sw0_off.jpg";
            });
        }
    });

    var PollGpios = function () {
        objGetReq.send({ url: 'data.xml' });
    };

    /*
    * Function to send request for the list of files contained by the Flash memory
    *
    ***************************************************************************/

    var objGetFileList = new Request({
        method: 'get',
        onSuccess: function (responseText, responseXML) {
            // only for debugging
            //alert(responseText);
            var set = Slick.search(responseXML, 'FILE');
            var ol = new Element('ol');
            var i = 1;
            set.each(function (item, index) {
                var name = item.getElement('NAME').get('text');
                var loc = item.getElement('LOCATION').get('text');
                var size = item.getElement('SIZE').get('text');
                var newLink = new Element('a', {
                    id: name + '#' + loc + '#' + size + '#' + i,
                    text: name,
                    href: '#'
                });
                i++;

                var li = new Element('li');
                var hr = new Element('hr');
                var br1 = new Element('br');
                var br2 = new Element('br');
                var spanAddr = new Element('span', {
                    text: 'Addr: 0x' + loc
                });
                var spanSize = new Element('span', {
                    text: 'Size: ' + size
                });
                // now construct the html elements
                // should look like this:
                // ...
                // <ol>
                //     <li>
                //         <a href="..." id=name>name.ext</a><br/>
                //         <span>Addr: ...</span><br/>
                //         <span>Size: ...</span>
                //     </li>
                //     ...
                // </ol>
                // ...
                ol.grab(li);
                hr.inject(ol);
                li.adopt(newLink);
                li.adopt(br1);
                li.adopt(spanAddr);
                li.adopt(br2);
                li.adopt(spanSize);
            });
            // inject <ol> to 'list' id'd element
            ol.inject(list);

            // set a variable telling the dispose() that an <ol>
            // element has been already generated
            alreadyOl = true;

            // create an event to store selected file
            var links = document.id('select').getElements('a');
            links.each(function (link) {
                link.addEvent('click', function (e) {
                    e.stop();

                    buc = link.get('id').split('#');

                    // now store the selected file
                    nameToSend = buc[0];
                    locationToSend = buc[1];
                    sizeToSend = buc[2];
                    IsLastFile = (buc[3] == links.length) ? true : false;

                    showRes.set('text', nameToSend);

                    // calculate location according to last file's size & location
                    if (IsLastFile) {
                        var s = parseInt(buc[2], 16);
                        var l = parseInt(buc[1], 16);
                        var ne = s + l;
                        newLocaUpld = ne.toString(16);
                        
                        while (newLocaUpld.length < 7) {
                            newLocaUpld = "0" + newLocaUpld;
                        }
                    }

                    // for debugging
                    //alert('Addr: ' + locationToSend + '\nSize: ' + sizeToSend + 
                    //'\nLast file: ' + IsLastFile + '\n' + newLocaUpld + '\nloc = ' + 
                    //l + '\nsize = ' + s + '\nne ' + ne);
                });
            });
        },
        onFailure: function () {
            showRes.set('text', 'Cannot get the file list');
        }
    });

    var DisposeDiv = function () {
        while (list.firstChild) {
            list.removeChild(list.firstChild);
        }
    }

    var GetList = function () {
        if (alreadyOl) {
            DisposeDiv();
        }
        objGetFileList.send({ url: 'flash/file/list' }); //for debugging: 'file_track.xml'
    };

    /*
    * Function to send a POST request for uploading a file to the server
    * (this function will also send a request for the XML file, on an upload
    * completed successfuly)
    *
    ***************************************************************************/
    var FileUpload = function (LocationToUpld) {

        // get the input file (only one) and its size in bytes
        var file = document.getElementById('fileInput').files[0];
        var fileSize = file.fileSize.toString(16);

        // check file size's length
        if (fileSize.length > 7) {
            alert("File too big, choose another one");
            return;
        }

        // fill size with '0's until length is 7-bit
        while (fileSize.length < 7) {
            fileSize = "0" + fileSize;
        }

        // fill location with '0's until length is 7-bit
        while (LocationToUpld.length < 7) {
            LocationToUpld = "0" + LocationToUpld;
        }

        // get the file name
        var filename;
        var fullPath = document.getElementById('fileInput').value;
        if (fullPath) {
            filename = fullPath.substring((fullPath.indexOf('\\') >= 0 ?
            fullPath.lastIndexOf('\\') : fullPath.lastIndexOf('/')));
            if (filename.indexOf('\\') === 0 || filename.indexOf('/') === 0) {
                filename = filename.substring(1);
            }
        }

        // for debugging
        //alert("upload/Name=" + filename + "&Size=" + fileSize);

        // create a new FileReader object
        var reader = new FileReader();
        reader.onloadend = function () {
            // create a new XHR object and send file
            var xhr = new XMLHttpRequest();
            xhr.open("POST", 'upload/Name=' + filename + '&Location=' + LocationToUpld + '&Size=' + fileSize, true);
            xhr.setRequestHeader("X-Requested-With", "XMLHttpRequest");
            xhr.setRequestHeader("X-File-Name", encodeURIComponent(filename));
            xhr.setRequestHeader("Content-Type", "application/octet-stream");
            xhr.upload.addEventListener("progress", function (e) {
                showRes.set('text', 'Uploading... ' + Math.floor(e.loaded / e.total * 100) + '%');
            }, false);
            xhr.upload.addEventListener("load", function (e) {
                showRes.set('text', 'Upload complete!');
                // now get the file list
                //GetList();
                while (list.firstChild) {
                    list.removeChild(list.firstChild);
                }
            }, false);
            xhr.send(file);
        }
        reader.readAsDataURL(file);
    };

    /*
    * Function that downloads a file from Flash memory
    *
    ***************************************************************************/
    // create a new Request object
    var objFileDownload = new Request({
        method: 'get',
        onProgress: function (responseText, responseXML) {
            showRes.set('text', 'Downloading file...');
        },
        onSuccess: function (responseText, responseXML) {
            showRes.set('text', 'Download complete!');
        },
        onFailure: function (responseText, responseXML) {
            showRes.set('text', 'Error downloading file!');
        }
    });

    var FileDownload = function (FileName, FileLocation, FileSize) {
        if (!FileName.length || !FileLocation.length || !FileSize.length) {
            showRes.set('text', 'Please select a file to download');
            return null;
        }
        var url = "download/Name=" + FileName + "&Location=" +
                    FileLocation + "&Size=" + FileSize;
        var elem = document.createElement("iframe");
        elem.src = url;
        elem.style.display = "none";
        document.body.appendChild(elem);
        //        objFileDownload.send({ url: 'download/Name=' + FileName + '&Location=' +
        //                    FileLocation + '&Size=' + FileSize
        //        });
    };

    /*
    * Function that delets the last file from Flash memory
    *
    ***************************************************************************/
    // create a new Request object
    var objFileDelete = new Request({
        method: 'get',
        onProgress: function () {
            showRes.set('text', 'Deleting file...');
        },
        onSuccess: function () {
            showRes.set('text', 'Delete complete!');
            // get the file list
            //GetList();
            while (list.firstChild) {
                list.removeChild(list.firstChild);
            }
        },
        onFailure: function () {
            showRes.set('text', 'Error deleting file!');
        }
    });

    var FileDelete = function (FileName, FileLocation, FileSize, IsLastFile) {
        if (!FileName.length || !FileLocation.length || !FileSize.length) {
            showRes.set('text', 'Please select a file to delete');
            return null;
        }
        else if (!IsLastFile) {
            showRes.set('text', 'Only the last file can be deleted');
            return null;
        }
        else {
            objFileDelete.send({ url: 'delete/Name=' + FileName + '&Location=' +
                     FileLocation + '&Size=' + FileSize
            });
        }
    };

    /*
    * Function that toggles the LED's current state
    *
    ***************************************************************************/
    var LedStateChange = function (LedNr) {
        switch (LedNr) {
            case (0):
                toggleLedState0 = !toggleLedState0;
                LedStateToServer.send({ url: 'Led/LedNr=0&State=' + toggleLedState0 });
                if (Response) {
                    if (toggleLedState0)
                        document.getElementById('led0').src = "pictures/leds/atlys_led0_on.jpg";
                    else
                        document.getElementById('led0').src = "pictures/leds/atlys_led0_off.jpg";
                }
                break;

            case (1):
                toggleLedState1 = !toggleLedState1;
                LedStateToServer.send({ url: 'Led/LedNr=1&State=' + toggleLedState1 });
                if (Response) {
                    if (toggleLedState1)
                        document.getElementById('led1').src = "pictures/leds/atlys_led1_on.jpg";
                    else
                        document.getElementById('led1').src = "pictures/leds/atlys_led1_off.jpg";
                }
                break;

            case (2):
                toggleLedState2 = !toggleLedState2;
                LedStateToServer.send({ url: 'Led/LedNr=2&State=' + toggleLedState2 });
                if (Response) {
                    if (toggleLedState2)
                        document.getElementById('led2').src = "pictures/leds/atlys_led2_on.jpg";
                    else
                        document.getElementById('led2').src = "pictures/leds/atlys_led2_off.jpg";
                }
                break;

            case (3):
                toggleLedState3 = !toggleLedState3;
                LedStateToServer.send({ url: 'Led/LedNr=3&State=' + toggleLedState3 });
                if (Response) {
                    if (toggleLedState3)
                        document.getElementById('led3').src = "pictures/leds/atlys_led3_on.jpg";
                    else
                        document.getElementById('led3').src = "pictures/leds/atlys_led3_off.jpg";
                }
                break;

            case (4):
                toggleLedState4 = !toggleLedState4;
                LedStateToServer.send({ url: 'Led/LedNr=4&State=' + toggleLedState4 });
                if (Response) {
                    if (toggleLedState4)
                        document.getElementById('led4').src = "pictures/leds/atlys_led4_on.jpg";
                    else
                        document.getElementById('led4').src = "pictures/leds/atlys_led4_off.jpg";
                }
                break;

            case (5):
                toggleLedState5 = !toggleLedState5;
                LedStateToServer.send({ url: 'Led/LedNr=5&State=' + toggleLedState5 });
                if (Response) {
                    if (toggleLedState5)
                        document.getElementById('led5').src = "pictures/leds/atlys_led5_on.jpg";
                    else
                        document.getElementById('led5').src = "pictures/leds/atlys_led5_off.jpg";
                }
                break;

            case (6):
                toggleLedState6 = !toggleLedState6;
                LedStateToServer.send({ url: 'Led/LedNr=6&State=' + toggleLedState6 });
                if (Response) {
                    if (toggleLedState6)
                        document.getElementById('led6').src = "pictures/leds/atlys_led6_on.jpg";
                    else
                        document.getElementById('led6').src = "pictures/leds/atlys_led6_off.jpg";
                }
                break;

            case (7):
                toggleLedState7 = !toggleLedState7;
                LedStateToServer.send({ url: 'Led/LedNr=7&State=' + toggleLedState7 });
                if (Response) {
                    if (toggleLedState7)
                        document.getElementById('led7').src = "pictures/leds/atlys_led7_on.jpg";
                    else
                        document.getElementById('led7').src = "pictures/leds/atlys_led7_off.jpg";
                }
                break;
        }
    };

    /*
    * Function to reset GPIO's state to default 'off'
    *
    ***************************************************************************/
    var ResetGpios = function () {
        // reset LED's
        document.getElementById('led0').src = "pictures/leds/atlys_led0_off.jpg";
        document.getElementById('led1').src = "pictures/leds/atlys_led1_off.jpg";
        document.getElementById('led2').src = "pictures/leds/atlys_led2_off.jpg";
        document.getElementById('led3').src = "pictures/leds/atlys_led3_off.jpg";
        document.getElementById('led4').src = "pictures/leds/atlys_led4_off.jpg";
        document.getElementById('led5').src = "pictures/leds/atlys_led5_off.jpg";
        document.getElementById('led6').src = "pictures/leds/atlys_led6_off.jpg";
        document.getElementById('led7').src = "pictures/leds/atlys_led7_off.jpg";

        // reset Pushbuttons
        document.getElementById('btnu').src = "pictures/pushbuttons/atlys_btnu_off.jpg";
        document.getElementById('btnl').src = "pictures/pushbuttons/atlys_btnl_off.jpg";
        document.getElementById('btnc').src = "pictures/pushbuttons/atlys_btnc_off.jpg";
        document.getElementById('btnr').src = "pictures/pushbuttons/atlys_btnr_off.jpg";
        document.getElementById('btnd').src = "pictures/pushbuttons/atlys_btnd_off.jpg";

        // reset Switches
        document.getElementById('sw0').src = "pictures/switches/atlys_sw0_off.jpg";
        document.getElementById('sw1').src = "pictures/switches/atlys_sw1_off.jpg";
        document.getElementById('sw2').src = "pictures/switches/atlys_sw2_off.jpg";
        document.getElementById('sw3').src = "pictures/switches/atlys_sw3_off.jpg";
        document.getElementById('sw4').src = "pictures/switches/atlys_sw4_off.jpg";
        document.getElementById('sw5').src = "pictures/switches/atlys_sw5_off.jpg";
        document.getElementById('sw6').src = "pictures/switches/atlys_sw6_off.jpg";
        document.getElementById('sw7').src = "pictures/switches/atlys_sw7_off.jpg";
    };

	/*
    // call GetList() function if 'Refresh file list' "button" was pressed
    $('shfiles').addEvent('click', function (e) {
        e.stop();
        GetList();
    }); */

    /*$('dupload').addEvent('click', function (e) {
        var ud = $('radios').getElement('input[name=group0]:checked').value;
        switch (ud) {
            case ("Upload"):
                e.stop();
                if ((newLocaUpld != null) && (newLocaUpld != 0)) {
                    FileUpload(newLocaUpld);
                }
                else {
                    alert('Click on a file in list to generate address where to upload file! \n' +
                          'Else the file will be uploaded to address 0x00');
                    newLocaUpld = "0000000";
                    FileUpload(newLocaUpld);
                }
                break;
            case ("Download"):
                e.stop();
                FileDownload(nameToSend, locationToSend, sizeToSend);
                break;
            case ("Delete"):
                e.stop();
                FileDelete(nameToSend, locationToSend, sizeToSend, IsLastFile);
                break;
        }
    });*/

    var periodical;

    // start/stop polling the GPIO's
    $('start_stop_poll').addEvent('click', function (e) {
        e.stop();
        startStop = !startStop;
        if (startStop) {
            // read every 'POLL_TIME_MS' the state of the sw's and btn's
            periodical = PollGpios.periodical(POLL_TIME_MS);
        }
        else {
            clearInterval(periodical);
            ResetGpios();
        }
    });

    // call the same LedStateChange function, according to the pressed LED
    $('led7').addEvent('click', function (event) {
        event.stop();
        LedStateChange(7);
    });
    $('led6').addEvent('click', function (event) {
        event.stop();
        LedStateChange(6);
    });
    $('led5').addEvent('click', function (event) {
        event.stop();
        LedStateChange(5);
    });
    $('led4').addEvent('click', function (event) {
        event.stop();
        LedStateChange(4);
    });
    $('led3').addEvent('click', function (event) {
        event.stop();
        LedStateChange(3);
    });
    $('led2').addEvent('click', function (event) {
        event.stop();
        LedStateChange(2);
    });
    $('led1').addEvent('click', function (event) {
        event.stop();
        LedStateChange(1);
    });
    $('led0').addEvent('click', function (event) {
        event.stop();
        LedStateChange(0);
    });
});

